// Take it Easy (Mensch rgere Dich nicht)
// author: 	u.seiffert
// date:		6.2008
// 
// =============================================
// remove the documentations for proper filesize
// =============================================
//
// all content made (and copyrigh) by u.seiffert
// song mixed by u.seiffert
// contest entry 3DGS summer contest 2008 by mercuryus
//-------------------------------------------------------------------------------------------------------

#define	_group		skill1	// group
#define	_id			skill2	// id in the group (0..3)
#define	_startnode	skill3	// number of the pawns node (1..4=house, 5=start, 45..48=goal)
#define	_clicked		skill21	// was klicked
#define	_canmove		skill22	// can be moved
#define	_destnode	skill23	// destnode
#define	_node			skill24	// node

// status request types
#define	rt_pawn_in_house		10
#define	rt_pawn_in_goal		20
#define	rt_pawn_on_road		30
#define	rt_pawn_on_start		40
#define	rt_pawn_can_kick		50
#define	rt_pawn_get_goal		60
#define	rt_pawn_can_move		70
#define	rt_pawn_at_goal		100

var		gv_wait				=	-1;						// adjust the speed here

ENTITY*	ent_temp[3];										// temp. used entitys (0=dice, 1=pawns, 2=diverse)
VECTOR	temp, t1;											// temp and dice-value vectors

var		gv_camang[3]		= {270, 89.9, 1300};		// camera rotation
var		gv_active_group 	= 0, goal_cnt;				// id of the active player (group of pawns), in_the_goal cunter

//---------------------------------------------------------------------------------------------------------------
// retrieve the dices value (the dice model has 6 indicator vertices to get analysed by their level)
function get_dice_value(){

	// reset
	vec_set(t1, nullvector); 
	
 	// get the highest reference vertex 
 	for(t1.x=33;t1.x<39;t1.x++){
 		vec_for_vertex(temp, ent_temp[0], t1.x);
 		if(temp.z>t1.y){
 			vec_set(t1, vector(t1.x, temp.z, t1.x-32));
		}
	}
 	return(t1.z);
}
//-------------------------------------------------------------------------------------------------------
// retrive the virtual field number 
// (each group follows its own path (->WED) the shared fields are calculated here)
function fieldno(ENTITY* p_ent, int p_add){
int lv_f = 0;
	
	// the virtual fields start with field 1 at the startpoint of group 0 (black)
	if(p_ent._node<5 || p_ent._node>44){return(0);}		
	lv_f=(p_ent._group*10+p_ent._node-4+p_add);
	if(lv_f>40){lv_f-=40;}
	return(lv_f);	
}
//-------------------------------------------------------------------------------------------------------
// get the group-number of the field
function group_on_field(p_field, p_group){

	ent_temp[2] = ent_next(NULL);
	while (ent_temp[2] != NULL){
		
		if(p_group==-1){
			// if my checkup field == my field
			if(p_field==fieldno(ent_temp[2], 0)){return(ent_temp[2]._group);}
		}else{
			if(p_field==ent_temp[2]._node && p_group==ent_temp[2]._group){return(1);}
		}		
		ent_temp[2]=ent_next(ent_temp[2]);
	}
	return(-1);
	
}
//-------------------------------------------------------------------------------------------------------
// move pawn to node
function move_pawn_to(ENTITY* p_ent, int p_node){

	if(p_ent._node<p_node){
		while(p_ent._node!=p_node){
			wait(gv_wait/10);
			p_ent._node+=1;
			path_getnode(p_ent, p_ent._node, temp, NULL);	
			vec_set(p_ent.x, temp);			
		}
	}else{
		p_ent._node=p_node;
		path_getnode(p_ent, p_ent._node, temp, NULL);	
		vec_set(p_ent.x, temp);
	}

}
//-------------------------------------------------------------------------------------------------------
// you are kicked
function get_kicked(ENTITY* p_ent, int p_field){

	// is a pawn kicked?
	ent_temp[2] = ent_next(NULL);
	while (ent_temp[2] != NULL){
		// an other pawn on my field???
		if(p_field==fieldno(ent_temp[2], 0) && p_ent!=ent_temp[2]){
			// fall down
			vec_add(ent_temp[2].x, vector(30,30,20));
			ent_temp[2].tilt=100;
			// laugh, wait and back to home
			media_play("laugh.wav", NULL, 100);
			wait(gv_wait);
			move_pawn_to(ent_temp[2], ent_temp[2]._startnode);
			ent_temp[2].tilt=0;
		}
		ent_temp[2] = ent_next(ent_temp[2]);
	}
}
//-------------------------------------------------------------------------------------------------------
// retrives the pawns best move
// all these states are prooved in order - the fist possible is processed
// 1. pawn is on the start field and can be moveed (no own pawn on the dest. field)
// 2. pawn is in the house, dice = 6, no own pawn on start field
// 3. pawn can kick an other pawn
// 4. pawn can reach his goal
// 5. pawn can move on
ENTITY* get_pawn2move(p_reqinfo, p_group, p_var){
	
	goal_cnt=0;	
	you = ent_next(NULL);
	while (you != NULL){
		
		switch(p_reqinfo){
			case rt_pawn_on_start:	// pawns on the start field
											if(you._group==p_group && you._node==5 && group_on_field(fieldno(you, p_var), -1)!=you._group){
												you._destnode=you._node+p_var;	// move on
												return(you);
											}
			case rt_pawn_in_house:	// pawns in the house
											if(you._group==p_group && you._node<5 && group_on_field(you._group*10+1, -1)!=you._group){
												you._destnode=5;	// goto start
												return(you);
											}
			case rt_pawn_can_kick:	// pawn can kick other player
											if(you._group==p_group && you._node>=5 && you._node+p_var<45 && group_on_field(fieldno(you, p_var), -1)>=0 && group_on_field(fieldno(you, p_var), -1)!=you._group){																								
												you._destnode=you._node+p_var;	// move on
												return(you);
											}
			case rt_pawn_get_goal:	// pawn can move
											if(you._group==p_group && you._node+p_var>44 && you._node+p_var<49 && group_on_field(you._node+p_var, you._group)==-1){											
												if(you._node<45){media_play("goal.wav", NULL, 100);}
												you._destnode=you._node+p_var;	// move on
												return(you);
											}
			case rt_pawn_can_move:	// pawn can move
											if(you._group==p_group && you._node>=5 && you._node+p_var<45 && group_on_field(fieldno(you, p_var), -1)==-1 && group_on_field(fieldno(you, p_var), -1)!=you._group){
												you._destnode=you._node+p_var;	// move on
												return(you);
											}
			case rt_pawn_at_goal:	// pawn is in the goal (and if all 4 then do not dice anymore!)
											if(you._group==p_group && you._node>=45){goal_cnt+=1;}
		}
		you = ent_next(you);
	}
	return(NULL);
	
}
//------------------------------------------------------------------------------------------------------
// the main loop 
function play(){
int lv_dice;	
	
	// easy listening
	media_loop("chillout1.mp3", NULL, 100);
	
	// give a little bit time to start...
	wait(-5);
	
	// main game loop
	while(1){
		
		// get the numver of pawns in the goal
		get_pawn2move(rt_pawn_at_goal, gv_active_group, 0);
		
		// as long as the player has a 6 (or at startup) and not all pawns are in the goal
		lv_dice=6;	
		while(lv_dice==6 && goal_cnt<4){
			
			// dice position
			path_getnode(ent_temp[0], gv_active_group+1, temp, NULL);
			vec_set(ent_temp[0].x, vector(temp.x, temp.y, 25));
			
			// roll the dice
			vec_set(ent_temp[0].pan,vector(90*integer(random(4)), 90*integer(random(4)), 90*integer(random(4))));
			lv_dice=get_dice_value();
			media_play("roll.wav", NULL, 100);
			
			// get pawn to move...
			// 1. a pawn on the start field			
			ent_temp[1]=get_pawn2move(rt_pawn_on_start, gv_active_group, lv_dice);
			
			// 2. out of the house!
			if(ent_temp[1]==NULL){
				if(lv_dice==6){
					ent_temp[1]=get_pawn2move(rt_pawn_in_house, gv_active_group, lv_dice);
				}
				
				// 3. kick it out!
				if(ent_temp[1]==NULL){
					ent_temp[1]=get_pawn2move(rt_pawn_can_kick, gv_active_group, lv_dice);
					
					// 4. reaching goal
					if(ent_temp[1]==NULL){
						ent_temp[1]=get_pawn2move(rt_pawn_get_goal, gv_active_group, lv_dice);
						
						// 5. continuing walk 
						if(ent_temp[1]==NULL){							
							ent_temp[1]=get_pawn2move(rt_pawn_can_move, gv_active_group, lv_dice);
						}
						
					}					
				}				
			}
			
			// move
			if(ent_temp[1]!=NULL){
				move_pawn_to(ent_temp[1], ent_temp[1]._destnode);	
				wait_for(move_pawn_to);
				if(ent_temp[1]._node<45){get_kicked(ent_temp[1], fieldno(ent_temp[1], 0));}
				wait_for(get_kicked);
			}
			
			wait(gv_wait);
		}
		
		// next!
		gv_active_group=(gv_active_group+1)%4;		
		wait(1);
	}
}
//-------------------------------------------------------------------------------------------------------
action act_dice(){
	ent_temp[0]=me;	
}
//-------------------------------------------------------------------------------------------------------
//uses: _group, _id, _startnode;
action act_pawn(){	
	my._node=my._startnode;
	my.skin=my._group+1;
}
//-------------------------------------------------------------------------------------------------------
// game loop
action act_starter(){
	
	// start playing
	play();
	
	// mouse mode
	mouse_mode=1;
	
	while(1){		
		// camera
		vec_set(gv_camang[0], vector((gv_camang[0]-mouse_right*mouse_force.x*time_step*20)%360, clamp(gv_camang[1]-mouse_right*mouse_force.y*time_step*20,15,89.9), clamp(gv_camang[2]+mickey.z*time_step*10,1000,2000)));
		vec_for_angle(temp, vector(gv_camang[0], gv_camang[1], 0));
		vec_normalize(temp, gv_camang[2]);
  		vec_set(camera.x, temp);
		vec_set(temp,nullvector);	
		vec_sub(temp,camera.x);
		vec_to_angle(camera.pan,temp);
		
		sun_angle.pan=camera.pan+240;	// sun shadow
		sun_angle.tilt=camera.tilt-180;
		wait(1);
	}
}
//--------------------------------------------------------------------------------------------------------
void main(){	
	// set video
	video_set(sys_metrics(0), sys_metrics(1), 32, 1);
	
	// level
	level_load("tie.wmb");	
	
	shadow_stencil=1;
	mat_shadow.alpha=20;	
	randomize();
	
}